<?php
/*
  $Id$

  Payment module

  Copyright (c) 2012 Eway

  Released under the GNU General Public License
*/

class eway_rapid extends base {
    var $code, $title, $description, $enabled, $auth_code, $transaction_id;

    var $enableDirectPayment = true;

    function eway_rapid() {
      global $order;

      $this->code = 'eway_rapid';
      $this->codeTitle = MODULE_PAYMENT_EWAYRAPID_TEXT_TITLE;
      $this->codeVersion = '1.3.9';
      $this->enableDirectPayment = true;
      $this->title = MODULE_PAYMENT_EWAYRAPID_TEXT_TITLE;

      if (MODULE_PAYMENT_EWAYRAPID_STATUS == 'True' && MODULE_PAYMENT_EWAYRAPID_LOGIN == '') {
        $this->title .=  '<span class="alert"> (Not Configured)</span>';
      } elseif (MODULE_PAYMENT_EWAYRAPID_MODE == 'Test') {
        $this->title .= '<span class="alert"> (in Testing mode)</span>';
      }

      $this->public_title = MODULE_PAYMENT_EWAYRAPID_TEXT_PUBLIC_TITLE;
      $this->description = MODULE_PAYMENT_EWAYRAPID_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_EWAYRAPID_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_EWAYRAPID_STATUS == 'True') ? true : false);

      if ((int)MODULE_PAYMENT_EWAYRAPID_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_EWAYRAPID_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();
    }

    function update_status() {
        global $order, $db;
        if ($this->enabled && (int)$this->zone > 0) {
          $check_flag = false;
          $sql = "SELECT zone_id
                  FROM " . TABLE_ZONES_TO_GEO_ZONES . "
                  WHERE geo_zone_id = :zoneId
                  AND zone_country_id = :countryId
                  ORDER BY zone_id";
          $sql = $db->bindVars($sql, ':zoneId', $this->zone, 'integer');
          $sql = $db->bindVars($sql, ':countryId', $order->billing['country']['id'], 'integer');
          $check = $db->Execute($sql);
          while (!$check->EOF) {
            if ($check->fields['zone_id'] < 1) {
              $check_flag = true;
              break;
            } elseif ($check->fields['zone_id'] == $order->billing['zone_id']) {
              $check_flag = true;
              break;
            }
            $check->MoveNext();
          }

          if (!$check_flag) {
            $this->enabled = false;
          }
        }
    }

    function javascript_validation() {
      return '  if (payment_value == "' . $this->code . '") {' . "\n" .
           '    var cc_holdername = document.checkout_payment.eway_cc_holdername.value;' . "\n" .
           '    var cc_number = document.checkout_payment.eway_cc_number.value;' . "\n" .
           '    if (cc_holdername == "" || eval(cc_holdername.length) < ' . CC_OWNER_MIN_LENGTH . ') {' . "\n" .
           '      error_message = error_message + "' . MODULE_PAYMENT_EWAYRAPID_TEXT_JS_CC_OWNER . '";' . "\n" .
           '      error = 1;' . "\n" .
           '    }' . "\n" .
           '    if (cc_number == "" || cc_number.length < ' . CC_NUMBER_MIN_LENGTH . ') {' . "\n" .
           '      error_message = error_message + "' . MODULE_PAYMENT_EWAYRAPID_TEXT_JS_CC_NUMBER . '";' . "\n" .
           '      error = 1;' . "\n" .
           '    }' . "\n" .
           '  }' . "\n";
    }

    function selection() {
       global $order;
       /**
       * since we are processing via the gateway, prepare and display the CC fields
       */
        $expires_month = array();
        $expires_year = array();
        $issue_year = array();
        for ($i = 1; $i < 13; $i++) {
          $expires_month[] = array('id' => sprintf('%02d', $i), 'text' => strftime('%B - (%m)',mktime(0,0,0,$i,1,2000)));
        }

        $today = getdate();
        for ($i = $today['year']; $i < $today['year'] + 7; $i++) {
          $expires_year[] = array('id' => strftime('%y', mktime(0,0,0,1,1,$i)), 'text' => strftime('%Y',mktime(0,0,0,1,1,$i)));
        }

        $onFocus = ' onfocus="methodSelect(\'pmt-' . $this->code . '\')"';

        $fieldsArray = array();
        $fieldsArray[] = array('title' => 'Cardholder Name:',
                               'field' => zen_draw_input_field('eway_cc_holdername', $order->billing['firstname'], 'id="'.$this->code.'-cc-ownerf"'. $onFocus . ' autocomplete="off"'),
                               'tag' => $this->code.'-cc-ownerf');
        $fieldsArray[] = array('title' => 'Credit Card Number:',
                               'field' => zen_draw_input_field('eway_cc_number', $ccnum, 'id="'.$this->code.'-cc-number"' . $onFocus . ' autocomplete="off"'),
                               'tag' => $this->code.'-cc-number');
        $fieldsArray[] = array('title' => 'Credit Card Expiry Date:',
                               'field' => zen_draw_pull_down_menu('eway_cc_expires_month', $expires_month, '', 'id="'.$this->code.'-cc-expires-month"' . $onFocus) . '&nbsp;' . zen_draw_pull_down_menu('eway_cc_expires_year', $expires_year, '', 'id="'.$this->code.'-cc-expires-year"' . $onFocus),
                               'tag' => $this->code.'-cc-expires-month');
        $fieldsArray[] = array('title' => 'CVV',
                               'field' => zen_draw_input_field('eway_cc_cvv', '', 'size="4" maxlength="4"' . ' id="'.$this->code.'-cc-cvv"' . $onFocus . ' autocomplete="off"'),
                               'tag' => $this->code.'-cc-cvv');

        return array('id' => $this->code,
                       'module' => $this->public_title,
                       'fields' => $fieldsArray);
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
        $confirmation = array('title' => '',
                          'fields' => array(array('title' => 'Cardholder Name:',
                                                  'field' => $_POST['eway_cc_holdername']),
                                            array('title' => 'Credit Card Number:',
                                                  'field' => substr($_POST['eway_cc_number'], 0, 4) . str_repeat('X', (strlen($_POST['eway_cc_number']) - 8)) . substr($_POST['eway_cc_number'], -4)),
                                            array('title' => 'Credit Card Expiry Date:',
                                                  'field' => strftime('%B, %Y', mktime(0,0,0,$_POST['eway_cc_expires_month'], 1, '20' . $_POST['eway_cc_expires_year']))
                                            )));
        return $confirmation;
    }

    function process_button() {
        // These are hidden fields on the checkout confirmation page
        $process_button_string = zen_draw_hidden_field('eway_cc_holdername', $_POST['eway_cc_holdername']) .
                                 zen_draw_hidden_field('eway_cc_expires_month', $_POST['eway_cc_expires_month']) .
                                 zen_draw_hidden_field('eway_cc_expires_year', substr($_POST['eway_cc_expires_year'], -2)) .
                                 zen_draw_hidden_field('eway_cc_number', $_POST['eway_cc_number']) .
                                 zen_draw_hidden_field('eway_cc_cvv', $_POST['eway_cc_cvv']);
        $process_button_string .= zen_draw_hidden_field(zen_session_name(), zen_session_id());

        return $process_button_string;
    }

    function before_process() {
        global $order, $order_totals, $db, $messageStack;

//        error_reporting(E_ALL);
//        ini_set("display_errors", 1);

        $amount = number_format($order->info['total'], 2, '.', '') * 100;
        $transact_url = zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL', true, false);
        $customerId = $_SESSION['customer_id'];				// customerId
        $merchantRef = $customerId."-".date("YmdHis");		// merchant reference

        require_once(realpath(dirname(__FILE__).'/eway_rapid/RapidAPI.php'));
        $username = MODULE_PAYMENT_EWAYRAPID_USERNAME;
        $password = MODULE_PAYMENT_EWAYRAPID_PASSWORD;
        $livemode = ( MODULE_PAYMENT_EWAYRAPID_MODE == 'True' ) ? false : true;
        $eway_service = new RapidAPI($livemode, $username, $password);

        // Create AccessCode Request Object
        $request = new CreateAccessCodeRequest();

        $request->Customer->Reference = 'zencart';
        $request->Customer->Title = 'Mr.';
        $request->Customer->FirstName = strval($order->billing['firstname']);
        $request->Customer->LastName  = strval($order->billing['lastname']);
        $request->Customer->CompanyName = '';
        $request->Customer->JobDescription = '';
        $request->Customer->Street1 = strval($order->billing['street_address']);
        $request->Customer->Street2 = strval($order->billing['suburb']);
        $request->Customer->City = strval($order->billing['city']);
        $request->Customer->State = strval($order->billing['state']);
        $request->Customer->PostalCode = strval($order->billing['postcode']);
        $request->Customer->Country = strtolower(strval($order->billing['country']['iso_code_2']));
        $request->Customer->Email = $order->customer['email_address'];
        $request->Customer->Phone = $order->customer['telephone'];
        $request->Customer->Mobile = '';

        // require field
        $request->ShippingAddress->FirstName = strval($order->delivery['firstname']);
        $request->ShippingAddress->LastName  = strval($order->delivery['lastname']);
        $request->ShippingAddress->Street1 = strval($order->delivery['street_address']);
        $request->ShippingAddress->Street2 = strval($order->delivery['suburb']);
        $request->ShippingAddress->City = strval($order->delivery['city']);
        $request->ShippingAddress->State = strval($order->delivery['state']);
        $request->ShippingAddress->PostalCode = strval($order->delivery['postcode']);
        $request->ShippingAddress->Country = strtolower(strval($order->delivery['country']['iso_code_2']));
        $request->ShippingAddress->Email = $order->customer['email_address'];
        $request->ShippingAddress->Phone = $order->customer['telephone'];
        $request->ShippingAddress->ShippingMethod = "Unknown";

        $invoiceDesc = '';
        foreach ($order->products as $product) {
            $item = new EwayLineItem();
            $item->SKU = $product['id'];
            $item->Description = $product['name'];
            $request->Items->LineItem[] = $item;
            $invoiceDesc .= $product['name'] . ', ';
        }
        $invoiceDesc = substr($invoiceDesc, 0, -2);
        if(strlen($invoiceDesc) > 64) $invoiceDesc = substr($invoiceDesc , 0 , 61) . '...';

        $request->Payment->TotalAmount = $amount;
        $request->Payment->InvoiceNumber = $merchantRef;
        $request->Payment->InvoiceDescription = $invoiceDesc;
        $request->Payment->InvoiceReference = '';
        $request->Payment->CurrencyCode = $order->info['currency'];

        $transact_url = str_replace('&amp;', '&', $transact_url);
        $request->RedirectUrl = $transact_url;
        $request->Method = 'ProcessPayment';

        //Call RapidAPI
        $result = $eway_service->CreateAccessCode($request);
        if (isset($result->Errors)) {
            //Get Error Messages from Error Code. Error Code Mappings are in the Config.ini file
            $ErrorArray = explode(",", $result->Errors);
            $lblError = "";
            foreach ( $ErrorArray as $error ) {
                if (isset($eway_service->APIConfig[$error]))
                    $lblError .= $error." ".$eway_service->APIConfig[$error]."<br>";
                else
                    $lblError .= $error;
            }
        }

        if (isset($lblError)) {
            $messageStack->add_session('checkout_payment', $lblError, 'error');
            zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL', true, false));
            return false;
        }

        // send post
        $AccessCode = $result->AccessCode;
        $cc_number = $_POST['eway_cc_number'];
        $post = array(
            EWAY_ACCESSCODE => $AccessCode,
            EWAY_CARDNAME   => $_POST['eway_cc_holdername'],
            EWAY_CARDNUMBER => $cc_number,
            EWAY_CARDEXPIRYMONTH  => $_POST['eway_cc_expires_month'],
            EWAY_CARDEXPIRYYEAR   => $_POST['eway_cc_expires_year'],
            EWAY_CARDCVN    => $_POST['eway_cc_cvv'],
        );

        $cc_owner_ip = zen_get_ip_address();
        $order->info['cc_number'] = substr($cc_number, 0, 4) . str_repeat('X', (strlen($cc_number) - 8)) . substr($cc_number, -4);
        $order->info['cc_owner']  = $_POST['eway_cc_holdername'];
        $order->info['cc_expires'] = '';
        $order->info['ip_address'] = $cc_owner_ip;

        foreach ($post as $key => $value) {
            $field_string .= "$key=" . urlencode( $value ) . "&";
        }

        $ch = curl_init($result->FormActionURL);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $xmlRequest);

        // Do not worry about checking for SSL certs
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);

        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, rtrim( $field_string, "& " ));

        $response_string = curl_exec($ch);

        if (curl_errno($ch)) {
            $messageStack->add_session('checkout_payment', curl_error($ch), 'error');
            zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL', true, false));
            return false;
        } else {
            curl_close($ch);
        }

        $isError = false;
        $request = new GetAccessCodeResultRequest();
        $request->AccessCode = $AccessCode;

        //Call RapidAPI to get the result
        $result = $eway_service->GetAccessCodeResult($request);

        // Check if any error returns
        if(isset($result->Errors)) {
            // Get Error Messages from Error Code. Error Code Mappings are in the Config.ini file
            $ErrorArray = explode(",", $result->Errors);
            $lblError = "";
            $isError = true;
            foreach ( $ErrorArray as $error ) {
                $error = trim($error);
                $lblError .= $eway_service->APIConfig[$error]."<br>";
            }
        }

        if (! $isError) {
            if (! $result->TransactionStatus) {
                $lblError = "Payment Declined - " . $result->ResponseCode;
                $isError = true;
            }
        }

        if ($isError) {
            $messageStack->add_session('checkout_payment', $lblError, 'error');
            zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL', true, false));
            return false;
        }

        // success
        $this->transaction_id = $result->TransactionID;
        $this->auth_code = $result->ResponseCode;
        return true;
    }

    function after_process() {
        global $insert_id, $db;

        $commentString = "eway TransactionID: " . $this->transaction_id;
        $sql_data_array= array(array('fieldName'=>'orders_id', 'value'=>$insert_id, 'type'=>'integer'),
                           array('fieldName'=>'orders_status_id', 'value' => $this->order_status, 'type'=>'integer'),
                           array('fieldName'=>'date_added', 'value'=>'now()', 'type'=>'noquotestring'),
                           array('fieldName'=>'customer_notified', 'value'=>0, 'type'=>'integer'),
                           array('fieldName'=>'comments', 'value'=>$commentString, 'type'=>'string'));
        $db->perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
    }

    function get_error() {
        $error = array('title' => MODULE_PAYMENT_LINKPOINT_API_TEXT_ERROR,
                       'error' => stripslashes(urldecode($_GET['error'])));
        return $error;
    }

    function check() {
      global $db;
      if (!isset($this->_check)) {
        $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_EWAYRAPID_STATUS'");
        $this->_check = !$check_query->EOF;
      }
      return $this->_check;
    }

    function install() {
        global $db, $messageStack;

        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable eWAY Payment Module', 'MODULE_PAYMENT_EWAYRAPID_STATUS', 'True', 'Do you want to authorize payment through eWAY Payment?', '6', '0', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");

		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Test Mode', 'MODULE_PAYMENT_EWAYRAPID_MODE', 'True', 'You can set to go to testing mode here.', '6', '0', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");

		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('eWAY API Key', 'MODULE_PAYMENT_EWAYRAPID_USERNAME', '', 'Your eWAY API Key registered when you join eWAY.', '6', '0', now())");

		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('eWay Password', 'MODULE_PAYMENT_EWAYRAPID_PASSWORD', '', 'Your eWAY password registered when you join eWAY.', '6', '0', now())");

		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_EWAYRAPID_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '0', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");

		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_EWAYRAPID_SORT_ORDER', '1', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
    }

    function remove() {
      global $db;
      $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_EWAYRAPID_STATUS', 'MODULE_PAYMENT_EWAYRAPID_MODE', 'MODULE_PAYMENT_EWAYRAPID_USERNAME', 'MODULE_PAYMENT_EWAYRAPID_PASSWORD', 'MODULE_PAYMENT_EWAYRAPID_ORDER_STATUS_ID', 'MODULE_PAYMENT_EWAYRAPID_SORT_ORDER');
    }

}